#ifndef __HEAP_H
#define __HEAP_H

#define MINHEAP 1
#define	MAXHEAP 2

struct THeapData {
	double key;
	int label;
	int x, y;
};
typedef struct THeapData HEAPDATA;

struct THeap{
	HEAPDATA *data;
	int heapType;
	int maxSize;
	int size;
};
typedef struct THeap HEAP;

HEAP initializeHeap(int maxSize, int heapType);
void freeHeap(HEAP H);

int insertHeap(HEAP *H, int x, int y, int label, double key);
int insertMaxHeap(HEAP *H, int x, int y, int label, double key);
int insertMinHeap(HEAP *H, int x, int y, int label, double key);

int deleteHeap(HEAP *H, HEAPDATA *item);
int deleteMaxHeap(HEAP *H, HEAPDATA *item);
int deleteMinHeap(HEAP *H, HEAPDATA *item);

#endif
